<?php
/**
 * Avatar Gallery v3.0
 * Copyright (c) 2001-2009 The XMB Group
 * http://www.xmbforum.com
 * Developed by John Briggs 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/

define('X_SCRIPT', 'avatars.php');

require 'header.php';

loadtemplates(
'avatar_gallery',
'avatar_gallery_multipage'
);

eval('$css = "'.template('css').'";');

// Warning: The following variables are used in template output.
$avatar = '';
$avatarfolder = './images/avatars';
$avatarname = array();
$avatars = '';
$multipage = '';
$subfolders = '';
$submitbutton = '';
$type = '';

$total = getInt('total', 'r');

$avatardir = array();
$dirf = opendir($avatarfolder);
while(false !== ($file = readdir($dirf))) {
    $avatardir[] = $file;
}
closedir($dirf);
sort($avatardir);

$type = postedVar('type', 'javascript', TRUE, FALSE, TRUE, 'r');
$typefound = FALSE;
foreach($avatardir as $value) {
    if ($value != '.' && $value != '..' && is_dir($avatarfolder.'/'.$value)) {
        if ($type == $value) {
            $typefound = TRUE;
            $folderimg = 'openav.gif';
            $pre = '<strong>';
            $suf = '</strong>';
        } else {
            $folderimg = 'closeav.gif';
            $pre = $suf = '';
        }
        $subfolders .= '<br />&nbsp;&nbsp;&nbsp;<img src="'.$imgdir.'/'.$folderimg.'" alt="'.$lang['altfolder'].'" border="0" /> <a href="avatars.php?type='.rawurlencode($value).'">'.$pre.$value.$suf.'</a>';
    }
}

if ($type != '' And !$typefound) {
    error($lang['folderdoesnotexist']);
}

nav('<a href="memcp.php">'.$lang['textusercp'].'</a>');

if (empty($type)) {
    nav($lang['avatars']);
} else {
    nav('<a href="avatars.php">'.$lang['avatars'].'</a>');
    nav($type);
}

eval('echo "'.template('header').'";');

eval($lang['evalwelcomeavatarmsg']);

if ($SETTINGS['avatargal'] == 'off') {
    error($lang['avatarfeaturedisabled'], false);
}

if (X_GUEST) {
    error($lang['avatarnologin'], false);
}

if (noSubmit('avatarsubmit')) {
    if ($type != '') {
        $avatarfolder .= '/'.$type.'/';
        $dir = opendir($avatarfolder);
        while(false !== ($file = readdir($dir))) {
            $size = filesize($avatarfolder.$file);
            $size = round(($size/100), 1);
            $ext = strtolower(substr(strrchr($file, '.'), 1));
            if ($file != '.' && $file != '..' && $file != 'index.html' && !is_dir($file) && (($ext == 'jpg' || $ext == 'gif' || $ext == 'png' || $ext == 'bmp' || $ext == 'jpeg') && $size > 1)) {
                $avatarname[] = $file;
            }
        }

        if (!empty($avatarname)) {
            closedir($dir);
            sort($avatarname);
            $totalc = count($avatarname);

            $mpurl = 'avatars.php?type='.$type;
            $mpage = multipage($totalc, $SETTINGS['avatargalpp'], $mpurl);
            $multipage =& $mpage['html'];
            if (strlen($mpage['html']) != 0) {
                eval('$multipage = "'.template('avatar_gallery_multipage').'";');
            }

            //Note < condition used below instead of <=
            $end_limit = $mpage['start'] + $SETTINGS['avatargalpp'];
            if ($end_limit > $totalc) {
                $end_limit = $totalc;
            }

            $listed_avatars = $frc = 0;
            for($a = $mpage['start']; $a < $end_limit; $a++) {
                $size = filesize($avatarfolder.'/'.$avatarname[$a]);
                $size = round(($size/1024), 1) . 'kb';

                if ($listed_avatars == 0) {
                    $avatars .= '<tr>';
                    $avatars .= "\n";
                    $frc++;
                }
                $avatars .= '<td class="ctrtablerow"><img src="'.$avatarfolder.''.$avatarname[$a].'" alt="'.$avatarname[$a].'" border="0" /><br /><font class="smalltxt">'.$size.'</font><br /><input type="radio" name="avataricon" value="'.$avatarfolder.''.$avatarname[$a].'" /></td>';
                $avatars .= "\n";

                $listed_avatars += 1;
                if ($listed_avatars == $SETTINGS['avatargalpr']) {
                    $avatars .= '</tr>';
                    $avatars .= "\n";
                    $listed_avatars = 0;
                }
                $total = count($avatarname[$a]);
            }

            for($z = 0; $z < (($frc * $SETTINGS['avatargalpr']) - ($end_limit - $mpage['start'])); $z++) {
                $avatars .= '<td class="ctrtablerow">&nbsp;</td>';
                $avatars .= "\n";
            }
        }
    }

    if (!empty($self['avatar'])) {
        $avatar = '<br />'.$lang['currentavatarmsg'].'<br /><br /><img src="'.$self['avatar'].'" alt="'.$lang['altavatar'].'"  border="0" /><br />';
    }

    if (empty($type) && $total == 0) {
        $avatars .= '<td class="ctrtablerow"><br />'.$lang['welcomeavatarmsg'].'<br />'.$avatar.'<br />'.$lang['navigateavatarmsg'].'<br /><br /></td></tr>';
        $avatars .= "\n";
    }

    if ($total > 0) {
        $submitbutton = '<tr><td class="ctrtablerow" bgcolor="'.$altbg2.'" colspan="2"><input type="submit" name="avatarsubmit" value="'.$lang['updateavatar'].'" /></td></tr>';
    } else if ($total < 0) {
        error($lang['noavatarsinfolder'], false);
    }
    eval('echo ("'.template('avatar_gallery').'");');
}

if (onSubmit('avatarsubmit')) {
    $avatar = postedVar('avataricon', 'javascript', TRUE, TRUE, TRUE);

    if ($avatar == '') {
        error($lang['noavatarselected'], false);
    }

    $type = substr($avatar, strlen($avatarfolder) + 1);
    $type = substr($type, 0, strrpos($type, '/'));
    $name = substr($avatar, strrpos($avatar, '/') + 1);

    $typefound = FALSE;
    $dirf = opendir($avatarfolder);
    while(false !== ($file = readdir($dirf))) {
        if ($type == $file) {
            if ($file != '.' && $file != '..' && is_dir($avatarfolder.'/'.$file)) {
                $typefound = TRUE;
            }
        }
    }
    closedir($dirf);

    if (!$typefound) {
        error($lang['folderdoesnotexist'], FALSE);
    }

    $filefound = FALSE;
    $avatarfolder .= '/'.$type.'/';
    $dir = opendir($avatarfolder);
    while(false !== ($file = readdir($dir))) {
        if ($name == $file) {
            $size = filesize($avatarfolder.$file);
            $size = round(($size/100), 1);
            $ext = strtolower(substr(strrchr($file, '.'), 1));
            if ($file != '.' && $file != '..' && $file != 'index.html' && !is_dir($file) && (($ext == 'jpg' || $ext == 'gif' || $ext == 'png' || $ext == 'bmp' || $ext == 'jpeg') && $size > 1)) {
                $filefound = TRUE;
            }
        }
    }

    if (!$filefound) {
        error($lang['filedoesnotexist'], FALSE);
    }

    $db->query("UPDATE ".X_PREFIX."members SET avatar='$avatar' WHERE username='$xmbuser'");
    
    message($lang['avatarupdated'], false, '', '', 'avatars.php', true, false, true);
}

end_time();
eval('echo "'.template('footer').'";');
?>
